/***************************************************************************/
NameMarker.prototype = new Microsoft.Maps.CustomOverlay({
    beneathLabels: false
}); // 扩展CustomOverlay
// NameOverlay定义
function NameMarker(opts) {
  // 初始化参数：坐标、文字、地图
	if ((typeof opts.icon) != "undefined") {
		this.icon_ = opts.icon;
	} else {
		this.icon_ = null;
	}
	//标记类型 1为点 15为站点 16为线路
    if ((typeof opts.markerType) != "undefined") {
   		this.markerType = opts.markerType;
  	} else {
  		this.markerType = null;
  	}
    //标记状态，主要记录站点 begin,end,station
    if((typeof opts.markerStatus) != "undefined") {
    	this.markerStatus = opts.markerStatus;
    }else {
    	this.markerStatus = null;
    }
	this.point_ = opts.position;
	this.text_ = opts.text || "";//显示名称 （轨迹回放显示真实车牌号）
	this.infoBox_ = opts.infobox || "";//弹窗信息
	this.map_ = opts.map;
	this.idno_ = opts.idno || "";//车牌号（轨迹回放使用的是临时车牌号）
	
	this.ignoreEnent_ = opts.ignoreEnent;//是否忽视事件
//	this.icon_ = opts.icon;
    // 到onAdd时才需要创建div
	this.div_ = null;
    // 加入map
	//使用点聚合
//	this.useMarkerClusterer = opts.useMarkerClusterer;
//	if(!this.useMarkerClusterer) {
//		this.setMap(this.map_);
//	}
	//自定义图层
	this.initialize = false;
	try {
		this.addToMap_();
	} catch (e) {
		alert("GFRAME.map.layers.insert: "+e);
		// TODO: handle exception
	}
}

//加入到地图上
NameMarker.prototype.addToMap_ = function(div){
	if(this.labelCanvasLoaded()){
		try {
			GFRAME.map.layers.insert(this);
		} catch (e) {
			// TODO: handle exception
		}
	}else{
		var that = this;
		setTimeout(function(){
			that.addToMap_(div);
		}, 200);
	}
} 


//判断画布是否加载成功
NameMarker.prototype.labelCanvasLoaded = function(){
	var  labelCanvas_ = document.getElementsByClassName("labelCanvas")
	if(labelCanvas_ && labelCanvas_[0]){
		return true;
	}
	return false;
} 

NameMarker.prototype.onAdd = function () {
    // 创建一个div，其中包含了当前文字
	if(this.point_){
		var div = document.createElement("div");
		div.id= this.point_.toString();//转换成字符串
		div.style.borderStyle = "none";
		div.style.borderWidth = "0px";
		div.style.position = "absolute";
		div.innerHTML = this.getHtml();
		this.div_ = div;
		//弹窗窗体的位置
		this.setHtmlElement(this.div_);
		this.initialize = true;
	}
};


function onclickEvents(e) {
	var idno = $(e).attr("data_id");
	var vehiIdno = $(e).attr("data_text");
	if(idno){
//		if(vehiIdno){//轨迹回放 车牌号 和队友的id不一样
		GFRAME.vehicleCenter = true;
//			GFRAME.openPopMarkerVehicle = vehiIdno;
//		}
		GFRAME.openPopMarkerVehicle = idno;
//		alert("onclickEvents:"+GFRAME.openPopMarkerVehicle);
		updateVehiclePopPlus(idno);
	}
};

function onmouseoverEvents(e) {
	var location_ = $(e).attr("data_point");
	var tips_ =  $(e).attr("data_text");
	if(location_ && tips_){
		GFRAME.tooltip.setOptions({
			location:  Microsoft.Maps.Location.parseLatLong($(e).attr("data_point")),
			htmlContent: GFRAME.tooltipTemplate.replace('{title}',  $(e).attr("data_text")),
			visible: true,
			offset: new Microsoft.Maps.Point(20, -40),
			maxHeight: 10,
			maxWidth: 100
		});
	}
};
function onmouseoutEvents(e) {
	GFRAME.tooltip.setOptions({
		visible: false
	});
};


NameMarker.prototype.repositionOverlay = function() {
	if(this.point_){
		var topLeft = 	GFRAME.map.tryLocationToPixel(this.point_, Microsoft.Maps.PixelReference.control);
		if (topLeft && this.div_) {
			this.div_.style.left = (topLeft.x-13) + 'px';
			this.div_.style.top = (topLeft.y-25)+ 'px';
			this.div_.style.width = '400px';
			this.div_.style.height = '32px';
		}
	}
 }


NameMarker.prototype.onLoad = function () {
   var that = this;
   that.repositionOverlay();
    //hide the position of the image when the view viewchange.
   Microsoft.Maps.Events.addHandler(GFRAME.map, 'viewchange', function () {
	   //隐藏窗口信息
//		if(GFRAME.popmarker){
//			GFRAME.popmarker.setMap(null);
//		}
//	    that.hideMarker();
	   //拖动就重新定位像素
		that.repositionOverlay();
   });
   //Update the position of the image when the view viewchangeend.
    Microsoft.Maps.Events.addHandler(GFRAME.map, 'viewchangeend', function () {
    	that.repositionOverlay();
    	that.showMarker();
    });
    //Update the position of the overlay when the map is resized.
    Microsoft.Maps.Events.addHandler(GFRAME.map, 'mapresize',   function () {
	   //隐藏窗口信息
		that.repositionOverlay();
   });
}

NameMarker.prototype.draw = function () {
	
};

NameMarker.prototype.onRemove = function () {
//	if(this.div_.parentNode){
//		this.div_.parentNode.removeChild(this.div_);
//	}
	this.div_ = null;
};
NameMarker.prototype.update = function(obj){
	if ((typeof obj.position) != "undefined") {
		this.setPosition(obj.position);
		this.repositionOverlay();
	}
	if ((typeof obj.icon) != "undefined") {
		this.setIcon(obj.icon);
	}
	if ((typeof obj.text) != "undefined") {
		this.setName(obj.text);
	}
	if((typeof obj.position) != "undefined" && (typeof obj.infobox) != "undefined"){
		if(GFRAME.popmarker){
			if (obj.text == GFRAME.openPopMarkerVehicle){
				//更新窗体信息 和位置
				GFRAME.popmarker.update({position:obj.position,text:obj.infobox});
			}
		}
	}
};

NameMarker.prototype.setPosition = function (position) {
	if (!Microsoft.Maps.Location.areEqual(this.point_, position)) {
		this.point_ = position;
	}
};

NameMarker.prototype.setIcon = function (icon) {
	if (this.icon_ != icon) {
		this.icon_ = icon;
		this.flash();
	}
};

NameMarker.prototype.setName = function (text) {
	if (this.text_ != text) {
		this.text_ = text;
		
		this.flash();
	}
};



NameMarker.prototype.getHtml = function() {
	var style = "";
	if(this.markerType != null && this.markerType == 1 && this.markerStatus) {//站点
		style = "style='position: absolute;top: 5px;left: 30px;'";
	}
	if (this.icon_ != null) {
		var jingweidu = this.point_.toString();
		var that = this;
		var img_  =	"<img style='cursor:pointer'" +
				"	src='" + this.icon_ + "' "+
				"   onclick='onclickEvents(this)'  " +
//				" 	onmouseover='onmouseoverEvents(this)' " +
//				"	onmouseout='onmouseoutEvents(this)' " +
				"   data_id=\""+this.idno_+"\" " +
				"   data_text=\""+this.text_+"\" " +
				"  	data_point=\'"+jingweidu.slice(jingweidu.indexOf("(")+1, jingweidu.indexOf(")"))+"\' " +
				"    '/>"
		return img_+"<span class='b' "+ style +">" + this.text_ + "</span>";
	} else {
		return "<span class='b'>" + this.text_ + "</span>";
	}
}

NameMarker.prototype.setMap = function(type){
	if(type){
		this.showMarker();
	}else{
		 GFRAME.map.layers.remove(this);
	}
};


NameMarker.prototype.flash = function () {
	if (this.div_) {
		this.div_.innerHTML = this.getHtml();
	}
}

NameMarker.prototype.flash = function () {
	if (this.div_) {
		this.div_.innerHTML = this.getHtml();
	}
}

NameMarker.prototype.hideMarker = function(){
	if (this.div_) {
		this.div_.style.visibility = "hidden";
	}
};
NameMarker.prototype.showMarker = function(){
	if (this.div_) {
		this.div_.style.visibility = "visible";
	}
};