/***************************************************************************/
//NameMarker.prototype = new  AMap.Marker(); // 扩展OverlayView
// NameOverlay定义
function NameMarker(opts) {
	
  // 初始化参数：坐标、文字、地图
	if ((typeof opts.icon) != "undefined") {
		this.icon_ = opts.icon;
	} else {
		this.icon_ = "";
	}
	//标记类型 1为点 15为站点 16为线路
    if ((typeof opts.markerType) != "undefined") {
   		this.markerType = opts.markerType;
  	} else {
  		this.markerType = null;
  	}
    //标记状态，主要记录站点 begin,end,station
    if((typeof opts.markerStatus) != "undefined") {
    	this.markerStatus = opts.markerStatus;
    }else {
    	this.markerStatus = null;
    }
	this.point_ = opts.position;
	this.text_ = opts.text || "";
	this.map_ = opts.map;
	
	this.marker_ = new AMap.Marker({
		map: GFRAME.map,
		position: this.point_,
		//http://localhost:8181/808gps/ttxmap/google/image/1/online/1.png 竖直  http://localhost:8181/808gps/ttxmap/google/image/1/online/2.png
		icon: new  AMap.Icon({image:/*"http://localhost:8181/808gps/ttxmap/google/image/1/online/2.png"*/this.icon_, imageOffset: new AMap.Pixel(7,7), size: new AMap.Size(46,46)}),
//	 zIndex: 7,
//	 32*32 车
		offset:{x:-23,y:-23}
	});
	this.marker_.setLabel({content:this.text_ ,offset:{x:35,y:13}});//文字偏移量
	this.clickObjType = opts.objType;
	this.clickObject = opts.vehicle;
	var veh = this.clickObject;
	if(this.clickObjType){
		this.marker_.on('click', function onMarkerClick() {
			markerClick(veh);
		});
	}
	   // 加入map
	this.useMarkerClusterer = opts.useMarkerClusterer;
	if(this.useMarkerClusterer) {//开启聚合点 直接把标记移除
//		this.marker_.hide();
	}
}




NameMarker.prototype.update = function(obj){
	var flash = false;
	if ((typeof obj.position) != "undefined") {
		this.setPosition(obj.position);
		flash = true;
	}	
	if ((typeof obj.icon) != "undefined") {
		this.setIcon(obj.icon);
		flash = true;
	}	
	if ((typeof obj.text) != "undefined") {
		this.setName(obj.text);
		flash = true;
	}
	if(flash) {//
//		this.flash();
	}
}

//刷新地图中点位置
NameMarker.prototype.flash = function () {
	this.map_.setCenter(this.marker_.getPosition());
}

//标记设置位置
NameMarker.prototype.setPosition = function (position) {
	var obj = this.marker_.getPosition();
	var isSameLat  =( obj.getLat() == position.getLat() ? true : false);
	var isSameLng  =( obj.getLng() == position.getLng() ? true : false);
	if (!(isSameLat && isSameLng)) {
		this.point_ = position;
		this.marker_.setPosition(position);
//		this.marker_.setMap(GFRAME.map);
//		GFRAME.map.setFitView([this.marker_/*, marker1*/]);
	}
}
//标记设置图标
NameMarker.prototype.setIcon = function (icon) {
	if (this.icon_ != icon) {
		this.icon_ = icon;
		this.marker_.setIcon(new  AMap.Icon({image:this.icon_, imageOffset: new AMap.Pixel(7,7), size: new AMap.Size(46,46)}));
	}
}
//标记设置名字
NameMarker.prototype.setName = function (text) {
	if (this.text_ != text) {
		this.text_ = text;
		
		this.marker_.setLabel({content:this.text_ ,offset:{x:35,y:13}});//文字偏移量
	}
}
