// JavaScript Document
// 瓦片地图界面渲染使用统一封装，底层都是谷歌相关的方法
// 谷歌地图和osm瓦片地图 谷歌瓦片地图统一渲染界面封装方法
var mapConfig = window._mapConfig || _getRootFrameAttributes(mapConfig).mapConfig;
window.mapobject = window.google || {};//设置全局的命名空间
mapobject.maps = google.maps || {};
mapobject.maps.MapTypeId = google.maps.MapTypeId || {};
var GALL_PETERS_RANGE_X = 256;
var GALL_PETERS_RANGE_Y = 256;
var GALL_PETERS_MIN_ZOOM = 3, GALL_PETERS_MAX_ZOOM = 18;
mapobject.maps.initMap = function (id, jindu, weidu, zoom) {
    this.MAP_CENTER_LAT = weidu;
    this.MAP_CENTER_LNG = jindu;
    this.MAX_ZOOM = zoom;
    this.container = id;
    var myLatlng = new mapobject.maps.LatLng(this.MAP_CENTER_LAT, this.MAP_CENTER_LNG);
    var mapTypeIds = null;
    if (mapConfig.isTilesMap()) {
        if (mapConfig.isGoogleTilesMap()) {
            mapTypeIds = ['google', 'google_satellite'];
        } else if (mapConfig.isOpenStreetTilesMap()) {
            mapTypeIds = ['OSM'];
        }
    } else if (mapConfig.isOffLineMap()) {
        mapTypeIds = ['google', 'google_satellite'];
    } else {
        mapTypeIds = [google.maps.MapTypeId.ROADMAP, google.maps.MapTypeId.SATELLITE, 'OSM'];
    }
    var lang_google_map_tag = (!mapConfig.isOutSeaVersion()) ? "地图" : "Google Map";
    var lang_map_satellite = (!mapConfig.isOutSeaVersion()) ? "卫星地图" : "Satellite";
    var myOptions = {
        //设置中心点
        center: myLatlng,
        //默认显示级别
        zoom: this.MAX_ZOOM,
        panControl: true,
        signInControl: false,
        scaleControl: true,
        // 将默认RoadMap取消，用'google'重写
        mapTypeControlOptions: {
            mapTypeIds: mapTypeIds/*,
            position: google.maps.ControlPosition.TOP_RIGHT*/
        }
    };
    //初始化map对象
    map = new google.maps.Map(document.getElementById(this.container), myOptions);
    //isTileMap
    var defaultMap = mapTypeIds[0];

    // 添加瓦片地图   谷歌 和 openStreetMap
    var gallPetersMapType = null;
    if (mapConfig.isTilesMap()) {
        if (mapConfig.isGoogleTilesMap()) {
            map.mapTypes.set("google", new google.maps.ImageMapType({
                getTileUrl: function (coord, zoom) {
                    //	var langType_ = 'en';
                    //	if (rootParent.lang.langType == 'zh') {
                    //		langType_ = 'zh-CN';
                    //	}
                    // 占时不传语言类型，app和客户端问题
                    // https://www.google.cn/maps/vt/lyrs=m&gl=cn&z=16&x=53488&y=28531
                    // http://www.google.com/maps/vt/"
                    var googleSatelliteTilesHome_ = mapConfig.googleOSMTilesHomeCn + "lyrs=m&gl=cn";
                    // 海外的链接
                    if (mapConfig.isOutSeaVersion()) {
                        googleSatelliteTilesHome_ = mapConfig.googleOSMTilesHome + "lyrs=m&gl=cn";
                    }
                    // 是否https
//					if (mapConfig.isHTTPS()) {
//						googleSatelliteTilesHome_ = mapConfig.replaceHttps(googleSatelliteTilesHome_);
//					}
                    return googleSatelliteTilesHome_ + '&z=' + zoom + "&x=" + coord.x + "&y=" + coord.y;
                },
                tileSize: new google.maps.Size(GALL_PETERS_RANGE_X, GALL_PETERS_RANGE_Y),
                name: lang_google_map_tag,
                maxZoom: GALL_PETERS_MAX_ZOOM,
                minZoom: GALL_PETERS_MIN_ZOOM
            }));

            gallPetersMapType = new google.maps.ImageMapType({
                getTileUrl: function (coord, zoom) {
                    //http://mt2.google.com/vt/lyrs=s&x=6687&y=3568&z=13
                    var googleSatelliteTilesHome_ = mapConfig.googleOSMTilesHomeCn + "lyrs=y&gl=cn";
                    // 海外的链接
                    if (mapConfig.isOutSeaVersion()) {
                        googleSatelliteTilesHome_ = mapConfig.googleOSMTilesHome + "lyrs=y&gl=cn";
                    }
//					if (mapConfig.isHTTPS()) {
//						googleSatelliteTilesHome_ = mapConfig.replaceHttps(googleSatelliteTilesHome_);
//					}
                    //hybrid  y
                    return googleSatelliteTilesHome_ + '&z=' + zoom + "&x=" + (coord.x) + "&y=" + (coord.y);
                },
                tileSize: new google.maps.Size(GALL_PETERS_RANGE_X, GALL_PETERS_RANGE_Y),
                name: lang_map_satellite,
                maxZoom: GALL_PETERS_MAX_ZOOM,
                minZoom: GALL_PETERS_MIN_ZOOM
            })
            map.mapTypes.set("google_satellite", gallPetersMapType);
            map.setTilt(45);

        } else if (mapConfig.isOpenStreetTilesMap()) {
            var openStreetOffline = mapConfig.openStreetTilesHomeCn;
            // 海外的链接
            if (mapConfig.isOutSeaVersion()) {
                openStreetOffline = mapConfig.openStreetTilesHome;
            }
            if (mapConfig.isHTTPS()) {
                openStreetOffline = mapConfig.replaceHttps(openStreetOffline);
            }
            gallPetersMapType = new google.maps.ImageMapType({
                getTileUrl: function (coord, zoom) {
                    return openStreetOffline + zoom + "/" + coord.x + "/" + (coord.y) + ".png";
                },
                tileSize: new google.maps.Size(GALL_PETERS_RANGE_X, GALL_PETERS_RANGE_Y),
                name: "OSM",
                maxZoom: GALL_PETERS_MAX_ZOOM,
                minZoom: GALL_PETERS_MIN_ZOOM
            })
            map.mapTypes.set("OSM", gallPetersMapType);
        }

    } else if (mapConfig.isOffLineMap()) {// 添加本地离线地图
        /**
         * 参考：https://stackoverflow.com/questions/23017766/google-maps-tile-url-for-hybrid-maptype-tiles
         * lyrs= 配置如下
         * h = roads only
         * m = standard roadmap
         * p = terrain
         * r = somehow altered roadmap
         * s = satellite only
         * t = terrain only
         * y = hybrid
         */
        map.mapTypes.set("google", new google.maps.ImageMapType({
            getTileUrl: function (coord, zoom) {
                return mapConfig.googleOfflineTileHome + zoom + "/" + coord.x + "/" + coord.y + ".jpg";
            },
            tileSize: new google.maps.Size(GALL_PETERS_RANGE_X, GALL_PETERS_RANGE_Y),
            name: lang_google_map_tag,
            maxZoom: GALL_PETERS_MAX_ZOOM,
            minZoom: GALL_PETERS_MIN_ZOOM
        }));
        // 添加卫星地图
        // 需要重写
        // 谷歌瓦片需要三份
        map.mapTypes.set("google_satellite", new google.maps.ImageMapType({
            getTileUrl: function (coord, zoom) {
                // 这个是不是要重新纠正位置
                return mapConfig.googleOfflineSateTileHome + zoom + "/" + coord.x + "/" + (coord.y) + ".jpg";
            },
            tileSize: new google.maps.Size(GALL_PETERS_RANGE_X, GALL_PETERS_RANGE_Y),
            name: lang_map_satellite,
            maxZoom: GALL_PETERS_MAX_ZOOM,
            minZoom: GALL_PETERS_MIN_ZOOM
        }));
    } else { // 官方地图引入OSM
        // 添加OSM地图
        map.mapTypes.set("OSM", new google.maps.ImageMapType({
            getTileUrl: function (coord, zoom) {
                var openStreetOffline = mapConfig.openStreetTilesHome;
                if (mapConfig.isHTTPS()) {
                    openStreetOffline = mapConfig.replaceHttps(openStreetOffline);
                }
                return openStreetOffline + zoom + "/" + coord.x + "/" + (coord.y) + ".png";
            },
            tileSize: new google.maps.Size(GALL_PETERS_RANGE_X, GALL_PETERS_RANGE_Y),
            name: "OSM",
            maxZoom: GALL_PETERS_MAX_ZOOM,
            minZoom: GALL_PETERS_MIN_ZOOM
        }));
    }
    //设置map对象默认显示 google 地图
    map.setMapTypeId(defaultMap);
    overlay = new google.maps.OverlayView();
    overlay.draw = function () {
    };
    overlay.setMap(map);
    // 显示瓦片位置工具
    // map.overlayMapTypes.insertAt(0, new CoordMapType(new google.maps.Size(GALL_PETERS_RANGE_X, GALL_PETERS_RANGE_Y)));
    return map;
};


//单击设置marker在地图中心，缩放级别放
function dblclickSetRoomCenter(weidu, jingdu, map) {
    var _zoom = map.getZoom();
    if (_zoom < 11) {
        map.setCenter(new mapobject.maps.LatLng(Number(weidu), Number(jingdu)));
        map.setZoom(11);
    } else if (_zoom >= 11 && _zoom <= 18) {
        map.setCenter(new mapobject.maps.LatLng(Number(weidu), Number(jingdu)));
        map.setZoom(_zoom + 2);
    }
}

var geocoder = new google.maps.Geocoder();

//调用googleAPI进行地址解析
function parseAddress(weidu, jingdu, arr, name) {
    if (!initParseAddress) {
        return;
    }
    if (document.getElementById(arr) != null) {
        geocoder.geocode({"address": weidu + "," + jingdu}, function (results, status) {
            if (name != "") {
                _str = "&nbsp;<span class='b'>" + name + ":</span>&nbsp;";
            } else {
                _str = "&nbsp;";
            }
            if (status == google.maps.GeocoderStatus.OK) {
                _str += results[0].formatted_address;
            } else {
                //_str += "Geocode was not successful for the following reason: " + status;
            }
            document.getElementById(arr).innerHTML = _str;
        });
    }
}

//调用googleAPI进行地址解析
function parseAddressEx(weidu, jingdu, callback) {
    geocoder.geocode({"address": weidu + "," + jingdu}, callback);
}

//调用googleAPI进行地址解析
function myParseAddress(jingdu, weidu, userdata) {
    geocoder.geocode({"address": weidu + "," + jingdu}, function (results, status) {
        var address = "";
        var ret = false;
        var error = 0;
        if (status == google.maps.GeocoderStatus.OK) {
            address = results[0].formatted_address;
            ret = true;
        } else {
            if (status == google.maps.GeocoderStatus.ZERO_RESULTS) {
                error = 1;
            } else if (status == google.maps.GeocoderStatus.OVER_QUERY_LIMIT) {
                error = 2;
            } else if (status == google.maps.GeocoderStatus.REQUEST_DENIED) {
                error = 3;
            } else {
                error = 4;
            }
            //ZERO_RESULTS		用于表示地理编码成功，但未返回任何结果。如果地理编码过程中传递的偏远位置 address 或 latlng 并不存在，就会出现这种情况
            //OVER_QUERY_LIMIT	用于表示您超出了自己的配额
            //REQUEST_DENIED	用于表示您的请求遭拒，这通常是由于缺少 sensor 参数
            //INVALID_REQUEST	通常用于表示缺少查询内容（address 或 latlng）
            //_str += "Geocode was not successful for the following reason: " + status;
        }
        if (isChrome) {
            app.sendMessage('OnParseAddress', [ret, address, userdata.toString(), error]);
        } else {
            window.external.OnParseAddress(ret, address, userdata.toString(), error);
        }
    });
}


/**
 * 显示瓦片位置工具
 */
function CoordMapType(tileSize) {
    this.tileSize = tileSize;
}

/**
 * 显示瓦片位置工具
 */
CoordMapType.prototype.getTile = function (coord, zoom, ownerDocument) {
    var div = ownerDocument.createElement('div');
    div.innerHTML = coord;
    div.style.width = this.tileSize.width + 'px';
    div.style.height = this.tileSize.height + 'px';
    div.style.fontSize = '10';
    div.style.color = 'red';
    div.style.borderStyle = 'solid';
    div.style.borderWidth = '1px';
    div.style.borderColor = '#AAAAAA';
    return div;
};